
'*******************************************************************************
'*****************      7-seg LED      ********************
'*******************************************************************************

' : ATMEGA88A    "AVR"    
'  : BASCOM-AVR 2.0.7.1
' : sasha_1973

'*******************************************************************************
'-------------------------------------------------------------------------------
'---------------            ----------------
'-------------------------------------------------------------------------------
  $regfile = "m88def.dat" : $crystal = 8000000 : $hwstack = 40 : $swstack = 16 : $framesize = 32
'-------------------------------------------------------------------------------
 '******************************************************************************
'-------------------------------------------------------------------------------
'---------------         LED      -----------------
'-------------------------------------------------------------------------------
' ******************************************************************************
'-------------------------------------------------------------------------------
'-------------       ,       -------------
'-------------------------------------------------------------------------------

  A Alias Portb.0       '  ,     "" LED 
  B Alias Portb.1       '  ,     "B" LED 
  C Alias Portb.2       '  ,     "C" LED 
  D Alias Portb.3       '  ,     "D" LED 
  E Alias Portb.4       '  ,     "E" LED 
  F Alias Portb.5       '  ,     "F" LED 
  G Alias Portb.6       '  ,     "G" LED 
  H Alias Portb.7       '  ,     "H" LED 

'------------------------

  _1 Alias Portd.4       '  ,    "1 " LED 
  _2 Alias Portd.5       '  ,    "2 " LED 
  _3 Alias Portd.6       '  ,    "3 " LED 
  _4 Alias Portd.7       '  ,    "4 " LED 

'-------------------------------------------------------------------------------
'---------       (,     )     ---------
'-------------------------------------------------------------------------------

  Config Portb = Output       '       

'           

  Config Portb.0 = Output       '      
  Config Portb.1 = Output       '      
  Config Portb.2 = Output       '      
  Config Portb.3 = Output       '      
  Config Portb.4 = Output       '      
  Config Portb.5 = Output       '      
  Config Portb.6 = Output       '      
  Config Portb.7 = Output       '      

'           , ,   

  Ddrb = &B11111111       '      (PORTB - ),   

'--------------------------

  Config Portd.4 = Output       '      
  Config Portd.5 = Output       '      
  Config Portd.6 = Output       '      
  Config Portd.7 = Output       '      

'            , ,   

  Ddrd = &B11110000       '      (PORTD - ),   
' ------------------------------------------------------------------------------

'   .
'   ,      .
'       ,   .
'    -    .     .

'-------------------------------------------------------------------------------
'-----------------             -------------------
'-------------------------------------------------------------------------------
_:       '  ,  
'-------------------------------------------------------------------------------

  Dim _ As Byte       ' ,     
  _ = 0       '  _ = 1 ,   ,  _ = 0 ,  A

'-------------------------------------

  Const __ = 4       ' ,       

  Const __ = 100       ' ,     "Waitms"
  Const __tcnt0_timer0 = 254       ' ,     TCNT0

'-------------------------------------------------------------------------------

  Dim  As Byte       ' ,     
  Dim _led As Byte       ' ,      (     )
  Dim _led As Word       ' ,    
  Dim _word As Word       ' ,    
  Dim _ As Word       '       
  Dim _ As Word       ' ,       _(n) = 1
  Dim _ As Byte       '   
  Dim __ As Byte       '      
  Dim __led As Byte       ' ,     
  Dim __led As Word       ' ,    
  Dim ___led As Word       ' ,      (     )
  Dim ___ As Word       ' ,        "_(n) = 1"
  Dim (__) As Byte       '    4- 
  Dim _(__) As Byte       '    8- 
  Dim _(__) As Byte       '      8- 
  Dim _(__) As Byte       '      8- 
  Dim _(__) As Byte       ' ,       __(n) = 1
  Dim __(__) As Byte       '        8- 

'-------------------------------------------------------------------------------
'----------------------           ------------------------
'-------------------------------------------------------------------------------

  Declare Sub _()
  Declare Sub _7seg_led()
  Declare Sub __timer0()

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'------------         LED      -----------
'-------------------------------------------------------------------------------

   Config Timer0 = Timer , Prescale = 1024 , Clear Timer = 0

'-------------------------------------------------------------------------------

'   ,        (  ),
'    "PRESCALE = 1024".
'     : f(  - 4) / 1024(  
' (  - 1 , 8 , 64 , 256 , 1024)) = 3906.25    ,
'     . ,      Datasheet
' ,  "TIMER0" ,   256,  3906,25 / 256 ~ 15,26   
'   Led  ( 8-      ~ 15,26 / 8 = "",
'  ).    ,  "Atmel"   ,
'    ,   .
' ,  ,    "TCNT0". Tcnt0 - 8- ( 0  255)   - (TIMER0).
'     .   ,   .

'-------------------------------------------------------------------------------
'          LED 
'-------------------------------------------------------------------------------

  Tcnt0 = __tcnt0_timer0       '     ( = 250)

'--------------------------------------------------------------------------------

'   ,   "TIMER0"     "0",    .
'  : 4000000 / 1024 / (256-( Tcnt0)) =  3906,25 / 6 ~ 651
' "TIMER0"  ,  1000(ms) /  651 ~ 1,536 ms,
'       7-seg LED .

' .

',   :  ,   ,
' ,      "TIMER0",   ,
'.

' ,       .

'-------------------------------------------------------------------------------
'-----------         TIMER0     ----------
'-------------------------------------------------------------------------------

   On Timer0 __timer0       '       TIMER0

'-------------------------------------------------------------------------------
'-----------------------          -----------------------
'-------------------------------------------------------------------------------

  _word = 50       ' ,   

  _ = 800       '      LED   "_(n) = 1"
  ___ = _ / 2       '      LED   "_(n) = 1"

'-------------------------------------------------------------------------------
'------------------------            ------------------------
'-------------------------------------------------------------------------------

    Enable Timer0       '       

    Enable Interrupts       '    

'-------------------------------------------------------------------------------
'*******************************************************************************
'***************************         ****************************
'*******************************************************************************
'-------------------------------------------------------------------------------
  Do : Nop
  _:       '  ,  
'--------------------------

    Decr _word       '  
    _led = _word       '    2  ( 4 )

    If _word = 0 Then       '    0,  "stop",  
        __(1) = 1 : _(1) = 5       '  "S"
        __(2) = 1 : _(2) = 14       '  "t"
        __(3) = 1 : _(3) = 15       '  "o"
        __(4) = 1 : _(4) = 28       '  "P"

        _(1) = 1       '  5 
        _(2) = 1       '  6 
        _(3) = 1       '  7 
        _(4) = 1       '  8 

    End If


    Waitms __
'--------------------
    Goto _
'--------------------
  Loop : End
'-------------------------------------------------------------------------------
'*******************************************************************************
'*****************                                ******************************
'*****************                    ******************************
'*****************                                ******************************
'*******************************************************************************

'-------------------------------------------------------------------------------
'*******************************************************************************
'*****************      TIMER0   ****************
'*****************            2,048 ms          ****************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __timer0:
'-------------------------------------------------------------------------------

    Rcall _7seg_led

'-------------------------------------------------------------------------------
'  TIMER0 = 1000/(1000000/1024/(256-254))=1000/(976,5625/2) = 2,048 ms
'-------------------------------------------------------------------------------

    Tcnt0 = __tcnt0_timer0

'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  _7seg_led:
'-------------------------------------------------------------------------------
'----------   ,           ---------
'-------------------------------------------------------------------------------
      __led = _led
      ___led = __led
'-------------------------------------------------------------------------------
'------------------       ,  4  1   -----------------
'-------------------------------------------------------------------------------
      For _led = __ To 1 Step -1
          __led = ___led Mod 10
          (_led) = __led       '
          ___led = ___led / 10       '
      Next
'-------------------------------------------------------------------------------
'----------------------         -----------------------
'-------------------------------------------------------------------------------
    rcall _       '  ,    ,       __led.       ,   .
'-------------------------------------------------------------------------------
'----    ,        -----
'-------------------------------------------------------------------------------
'-----           7-seg LED     -----
'-------------------------------------------------------------------------------
    If __ = 1 Then       '      ,  
        Incr _
        If _ > __ Then _ = 1
        __ = 0
    End If
'-------------------------------------------------------------------------------
'      ,     
'-------------------------------------------------------------------------------
'----------------------------       --------------------------
'-------------------------------------------------------------------------------
    Incr _

    If _ > _ Then _ = 1
'-------------------------------------------------------------------------------
'------------------    ,       ------------------
'-------------------------------------------------------------------------------
    If _(_) = 1 And _ > ___ Or _(_) = 1 Then       '         > 200
        Select Case _
          Case 1 To 4
            If _ = 1 Then
                __led = Lookup(11 , _ok)       '     1 - 4 
              Else
                __led = Lookup(11 , _oa)       '     1 - 4 
            End If
        End Select
      Else
'-------------------------------------------------------------------------------
'-----------------------        ---------------------
'-------------------------------------------------------------------------------
        If __(_) = 1 Then
            Select Case _
              Case 1 To 4
                If _ = 1 Then
                    __led = Lookup(_(_) , _ok)       '  _  1 - 4 
                  Else
                    __led = Lookup(_(_) , _oa)       '  _  1 - 4 
                End If
            End Select
          Else
'-------------------------------------------------------------------------------
'-------          ,     ------
'-------------------------------------------------------------------------------
            __led = (_)
              Select Case _
                Case 1 To 4
                  If _ = 1 Then
                      __led = Lookup(__led , _ok)       '     ,    1 - 4 
                    Else
                      __led = Lookup(__led , _oa)       '     ,    1 - 4 
                  End If
              End Select
        End If
'-------------------------------------------------------------------------------
'-------------    ,        -------------
'-------------------------------------------------------------------------------
      If _(_) = 1 Then
          __led = __led Xor &H80       '&H80  &B10000000     
      End If
'-------------------------------------------------------------------------------
'   "     ,     "
'-------------------------------------------------------------------------------
    End If
'-------------------------------------------------------------------------------
'---------------------            ------------------------
'-------------------------------------------------------------------------------
          '

    If _ = 1 Then
        Portb = &B00000000
      Else
        Portb = &B11111111
    End If

       ' 

'    If _ = 1 Then
'        Portb.0 = 0
'        Portb.1 = 0
'        Portb.2 = 0
'        Portb.3 = 0
'        Portb.4 = 0
'        Portb.5 = 0
'        Portb.6 = 0
'        Portb.7 = 0
'      Else
'        Portb.0 = 1
'        Portb.1 = 1
'        Portb.2 = 1
'        Portb.3 = 1
'        Portb.4 = 1
'        Portb.5 = 1
'        Portb.6 = 1
'        Portb.7 = 1
'    End If
'-------------------------------------------------------------------------------
'---------------         ----------------
'-------------------------------------------------------------------------------
    Select Case _
'-------------------------------------------------------------------------------
'----------------------------        ---------------------------
'-------------------------------------------------------------------------------
      Case 1 :
               If _ = 1 Then       '    ,   "0"  ,    ,   "1"
                   Reset _1
                 Else
                   Set _1
               End If
'-------------------------------------------------------------------------------
'-----------------     ,      -------------------
'-------------------------------------------------------------------------------
      Case 2 : If _ = 1 Then Reset _2 Else Set _2
      Case 3 : If _ = 1 Then Reset _3 Else Set _3
      Case 4 : If _ = 1 Then Reset _4 Else Set _4
    End Select
'-------------------------------------------------------------------------------
'---------------------            ------------------------
'-------------------------------------------------------------------------------
    If  < 8 Then
        Portb. = __led.
      Else
        Portd. = __led.
    End If
'-------------------------------------------------------------------------------
'-------------------           -----------------
'-------------------------------------------------------------------------------
    Incr        '  
    If  > 7 Then       '   ,    
         = 0
        __ = 1       '  ,      ,   
    End If
'-------------------------------------------------------------------------------
'-----------------------   ,    -----------------------
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************

'        A = __led.0                 '  ""
'        B = __led.1                 '  "B"
'        C = __led.2                 '  "C"
'        D = __led.3                 '  "D"
'        E = __led.4                 '  "E"
'        F = __led.5                 '  "F"
'        G = __led.6                 '  "G"
'        H = __led.7                 '  ""
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  _:
'-------------------------------------------------------------------------------
    If _ = 1 Then
'-------------------------------------------------------------------------------
'----------------------------        ---------------------------
'-------------------------------------------------------------------------------
        Set _1 : Set _2 : Set _3 : Set _4       '   ,
'-------------------------------------------------------------------------------
'-----------------     ,      -------------------
'-------------------------------------------------------------------------------
'        _1 = 1       '   ,
'        _2 = 1
'        _3 = 1
'        _4 = 1
'-------------------------------------------------------------------------------
'-------------------------         ----------------------------
'-------------------------------------------------------------------------------
'        _1 = 1 : _2 = 1 : _3 = 1 : _4 = 1       '   ,
'-------------------------------------------------------------------------------
      Else
        Reset _1 : Reset _2 : Reset _3 : Reset _4       '   
    End If
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  _ok:
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'----------------------------        ---------------------------
'-------------------------------------------------------------------------------
'    Data &H3F , &H06 , &H5B , &H4F , &H66 , &H6D , &H7D , &H07 , &H7F , &H6F       '0, 1, 2, 3, 4, 5, 6, 7, 8, 9
'    Data &H40 , &H00 , &H63 , &H39 , &H78 , &H5C , &H38 , &H74 , &H5E , &H77       '"-", "", " ", "", "t", "o", "L", "h", "d", "A"
'    Data &H58 , &H31 , &H76 , &H79 , &H50 , &H71 , &H1C , &H73 , &H37 , &H80       '"c", "", "", "E", "r", "F", "U", "u", "P", "". "."
'    Data &H54       ', &H , &H , &H , &H , &H , &H , &H , &H , &H '"n", "", "", "", "", "", "", "", "", "". ""
'-------------------------------------------------------------------------------
'-------     ,  ,       ------
'-------------------------------------------------------------------------------
    Data &H3F       ' 0   "0"
    Data &H06       ' 1   "1"
    Data &H5B       ' 2   "2"
    Data &H4F       ' 3   "3"
    Data &H66       ' 4   "4"
    Data &H6D       ' 5   "5"
    Data &H7D       ' 6   "6"
    Data &H07       ' 7   "7"
    Data &H7F       ' 8   "8"
    Data &H6F       ' 9   "9"
    Data &H40       ' 10  "_"
    Data &H00       ' 11  " "
    Data &H63       ' 12  " "
    Data &H39       ' 13  ""
    Data &H78       ' 14  "t"
    Data &H5C       ' 15  "o"
    Data &H38       ' 16  "L"
    Data &H74       ' 17  "h"
    Data &H5E       ' 18  "d"
    Data &H77       ' 19  "A"
    Data &H58       ' 20  "c"
    Data &H31       ' 21  ""
    Data &H76       ' 22  "H"
    Data &H79       ' 23  "E"
    Data &H50       ' 24  "r"
    Data &H71       ' 25  "F"
    Data &H3E       ' 26  "U"
    Data &H1C       ' 27  "u"
    Data &H73       ' 28  "P"
    Data &H37       ' 29  ""
    Data &H80       ' 30  ""
    Data &H54       ' 31  "n"
'-------------------------------------------------------------------------------
  _oa:
'-------------------------------------------------------------------------------
    Data &HC0 , &HF9 , &HA4 , &HB0 , &H99 , &H92 , &H82 , &HF8 , &H80 , &H90       '0,1,2,3,4,5,6,7,8,9
    Data &HBF , &HFF , &H9C , &HC6 , &H87 , &HA3 , &HC7 , &H8B , &HA1 , &H88       '"-", "", " ", "", "t", "o", "L", "h", "d", "A"
    Data &HA7 , &HCE , &H89 , &H86 , &HAF , &H8E , &HC1 , &HE3 , &H8C , &HC8       '"c", "", "", "E", "r", "F", "U", "u", "P", ""
    Data &H7F , &HAB       ', &H , &H , &H , &H , &H , &H , &H , &H , &H ' "." , "n", "", "", "", "", "", "", "", "", "". ""
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------